# bdm::BMEF Class Reference

Estimator for Exponential family. More...

## Detailed Description

Estimator for Exponential family.

`#include <exp_family.h>`

List of all members.

## Public Member Functions
| BMEF (double frg0=1.0)
| Default constructor (=empty constructor).
| BMEF (const BMEF &B)
| Copy constructor.
virtual void | set_statistics (const BMEF *BM0)
| get statistics from another model
virtual void | bayes (const vec &data, const double w)
| Weighted update of sufficient statistics (Bayes rule).
void | bayes (const vec &dt)
| Incremental Bayes rule.
virtual void | flatten (const BMEF *B)
| Flatten the posterior according to the given BMEF (of the same type!).
BMEF * | _copy_ () const
| Copy function required in vectors, Arrays of BM etc. Have to be DELETED manually! Prototype:.
void | from_setting (const Setting &set)
| This method arrange instance properties according the data stored in the Setting structure.
virtual string | to_string ()
| This method returns a basic info about the current instance.
virtual void | to_setting (Setting &set) const
| This method save all the instance properties into the Setting structure.
virtual void | validate ()
| This method TODO.
Mathematical operations
virtual void | bayesB (const mat &Dt)
| Batch Bayes rule (columns of Dt are observations).
virtual double | logpred (const vec &dt) const
vec | logpred_m (const mat &dt) const
| Matrix version of logpred.
virtual epdf * | epredictor () const
| Constructs a predictive density .
virtual mpdf * | predictor () const
| Constructs conditional density of 1-step ahead predictor .
Access to attributes
access function
const RV & | _drv () const
void | set_drv (const RV &rv)
| access function
void | set_rv (const RV &rv)
| access to rv of the posterior
double | _ll () const
| return internal log-likelihood of the last data vector
void | set_evalll (bool evl0)
| switch evaluation of log-likelihood on/off
virtual const epdf & | posterior () const =0
| return posterior density
## Protected Attributes
double | frg
| forgetting factor
double | last_lognc
| cached value of lognc() in the previous step (used in evaluation of `ll` )
RV | drv
| Random variable of the data (optional).
double | ll
| Logarithm of marginalized data likelihood.
bool | evalll
| If true, the filter will compute likelihood of the data record and store it in `ll` . Set to false if you want to save computational time.
## Extension to conditional BM
This extension is useful e.g. in Marginalized Particle Filter (bdm::MPF). Alternatively, it can be used for automated connection to DS when the condition is observed
const RV & | _rvc () const
| access function
virtual void | condition (const vec &val)
| Substitute `val` for `rvc`.
RV | rvc
| Name of extension variable.
## Logging of results
virtual void | set_options (const string &opt)
| Set boolean options from a string, recognized are: "logbounds,logll".
virtual void | log_add (logger &L, const string &name="")
| Add all logged variables to a logger.
virtual void | logit (logger &L)
| Save results to the given logger, details of what is stored is configured by `LIDs` and `options`.
ivec | LIDs
| IDs of storages in loggers 4:[1=mean,2=lb,3=ub,4=ll].
ivec | LFlags
| Flags for logging - same size as LIDs, each entry correspond to the same in LIDs.

## Member Function Documentation

BMEF* bdm::BMEF::_copy_ | ( |  | ) | const`[inline, virtual]`

Copy function required in vectors, Arrays of BM etc. Have to be DELETED manually! Prototype:.

     BM* _copy_() const {return new BM(*this);}

Reimplemented from bdm::BM.

Reimplemented in bdm::ARX, and bdm::ARXfrg.

References bdm_error.

Referenced by bdm::MixEF::init().

void bdm::BMEF::bayes | ( | const vec & | dt | ) | `[virtual]`

Incremental Bayes rule.

Parameters:

  | dt | vector of input data

Implements bdm::BM.

Reimplemented in bdm::ARX, bdm::MixEF, and bdm::multiBM.

References bayes().

virtual double bdm::BM::logpred | ( | const vec & | dt | ) | const`[inline, virtual, inherited]`

Evaluates predictive log-likelihood of the given data record I.e. marginal likelihood of the data with the posterior integrated out.

Reimplemented in bdm::ARX, bdm::MixEF, and bdm::multiBM.

References bdm_error.

Referenced by bdm::BM::logpred_m().

The documentation for this class was generated from the following files:

- exp_family.h
- exp_family.cpp